//
//  OverLayView.swift
//  OCR-SDK
//
//  Created by Nguyen Van An on 4/26/21.
//  Copyright © 2021 itsol. All rights reserved.
//


import AVFoundation
import UIKit
class OverLayCardView: UIView {
    @IBInspectable var previewWidth: CGFloat = 100
    @IBInspectable var previewHeight: CGFloat = 100
    @IBInspectable var borderLength : CGFloat = 10
    @IBInspectable var borderPadding : CGFloat = 0
    @IBInspectable var borderWidth : CGFloat = 2
    @IBInspectable var borderColor : CGColor = UIColor.white.cgColor
    @IBInspectable var marginTop : CGFloat = 0
    @IBInspectable var marginLeft : CGFloat = 0
    @IBInspectable var connerRadius : CGFloat = 8
    
    let vContainer: UIView = {
        let view = UIView()
        view.backgroundColor =  UIColor.black.withAlphaComponent(0.6)
        return view
    }()
    let vContainer2: UIView = {
        let view = UIView()
        return view
    }()
    override init(frame: CGRect) {
        super.init(frame: frame)
        vContainer.frame = self.bounds
        self.addSubview(vContainer)
        vContainer2.frame = self.bounds
        self.addSubview(vContainer2)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    func setLayer(){
        var x = marginTop
        var y = marginLeft
        if marginTop == 0 {
            x = self.center.x - previewWidth/2
        }
        if marginLeft == 0 {
            y = self.center.y - previewHeight/2
        }
        //add to container dask
        let maskLayer = CALayer()
        maskLayer.frame = self.bounds
        let circleLayer = CAShapeLayer()
        circleLayer.frame = CGRect(x:0 , y:0,width: self.frame.size.width,height: self.frame.size.height)
        let finalPath = UIBezierPath(roundedRect: CGRect(x:0 , y:0,width: self.frame.size.width,height: self.frame.size.height), cornerRadius: 0)
        let rectPath = UIBezierPath(roundedRect: CGRect(x: x, y: y,width: previewWidth, height: previewHeight),  cornerRadius: connerRadius)
        finalPath.append(rectPath.reversing())
        circleLayer.path = finalPath.cgPath
        maskLayer.addSublayer(circleLayer)
        vContainer.layer.mask = maskLayer
        let clearLayer = CALayer()
        clearLayer.frame = vContainer2.bounds
        
        //draw border radius
        let path = UIBezierPath(roundedRect: CGRect(x: x + borderPadding, y: y + borderPadding, width: previewWidth - borderPadding*2, height: previewHeight - borderPadding*2),  cornerRadius: connerRadius)
        let shape = CAShapeLayer()
        shape.path = path.cgPath
        shape.strokeColor = borderColor
        shape.lineWidth = borderWidth
        shape.fillColor = UIColor.clear.cgColor
        vContainer2.layer.addSublayer(shape)
    }
    
    func setBorderColor(color: CGColor){
        if borderColor != color {
            vContainer2.layer.sublayers = nil
            borderColor = color
            var x = marginTop
            var y = marginLeft
            if marginTop == 0 {
                x = self.center.x - previewWidth/2
            }
            if marginLeft == 0 {
                y = self.center.y - previewHeight/2
            }
        //draw border radius
        let path = UIBezierPath(roundedRect: CGRect(x: x + borderPadding, y: y + borderPadding, width: previewWidth - borderPadding*2, height: previewHeight - borderPadding*2),  cornerRadius: connerRadius)
        let shape = CAShapeLayer()
        shape.path = path.cgPath
        shape.strokeColor = borderColor
        shape.lineWidth = borderWidth
        shape.fillColor = UIColor.clear.cgColor
        vContainer2.layer.addSublayer(shape)
        }
    }
    
}

